
#include <t_services.h>

/*
 *  各タスクの優先度の定義
 */

#define MAIN_PRIORITY   5       /* メインタスクの優先度 */
                    /* HIGH_PRIORITY より高くすること */

#define HIGH_PRIORITY   9       /* 並列に実行されるタスクの優先度 */
#define MID_PRIORITY    10
#define LOW_PRIORITY    11

/*
 *  ターゲット依存の定義（CPU例外ハンドラの起動方法など）
 */


#if defined(BLACKFIN)

#define CPUEXC1     0      /* CPU例外ハンドラ番号 */
#define RAISE_CPU_EXCEPTION asm("excpt 0;") /* ソフトウェア割込み発生 */
#define STACK_SIZE  1024     /* タスクのスタックサイズ */
#define TASK_PORTID 1       /* 文字入力するシリアルポートID */

#endif

/*
 *  ターゲットに依存する可能性のある定数の定義
 */

#ifndef TASK_PORTID
#define TASK_PORTID 1       /* 文字入力するシリアルポートID */
#endif /* TASK_PORTID */


/*
 *  関数のプロトタイプ宣言
 */
#ifndef _MACRO_ONLY

extern void main_task(VP_INT exinf);

#endif /* _MACRO_ONLY */
